/*
 * mic.h - support funstions
 *
 * Michal Ludvig <michal@ludvig.cz>
 * started: 25 Aug 1996
 *
 */

#ifndef __MIC_H__
#define __MIC_H__

#include <stdio.h>
#include "mic_t.h"

#define helparg(x) (((x[0]=='-')||(x[0]=='/'))&&\
                   ((x[1]=='H')||(x[1]=='h')||(x[1]=='?')))

#define PW2(x) ((x)*(x))
#define PW3(x) ((x)*(x)*(x))

#ifdef __cplusplus
extern "C"
{
#endif
	/* print 'exitmsg' to stderr (printf string format) */
	/* and exit program with 'exitcode' */
	void failprog(unsigned char exitcode, const char *exitmsg, ...);
	
	/* get value of parameter from specified section of config file */
	/* returns: 0 - not succesfull, 1 - 'value' contains valid data */
	int parseconf(FILE *f, const char *section, 
			const char *parameter, char *value);
	
#ifndef _errstr_
#define _errstr_
	/* Return string coresponding to given errval (usualy errno) */
	const char *errstr(int errval);
	
	/* Return verbose string coresponding to given errval (usualy errno) */
	const char *errverb(int errval);
#endif  _errstr_

#ifdef __cplusplus
}
#endif


#endif	__MIC_H__
