#include <getopt.h>

#include "mic.h"
#include "config.h"
#include "vyroci.h"

#define	debug	dummy

/**** global variable ****/
tconfig	cfg;

void usage()
{
	puts("\
Pouziti: vyroci <mode> [options]

<mode>

Check
 c  ...  Prohledat databaze vzhledem k dnesnimu datu 
         [tato volba se pouzije, pokud neni zadan jiny <mode>]
  
  -d dd/mm/yyyy  Misto dnesniho data se pouzije datum zadane
  
  -a             annual  \\\
\n  -n             nameday  > Prohledat bez ohledu na konfiguracni soubor
  -o             onetime /

  -A             annual  \\\
\n  -N             nameday  > Neprohledavat bez ohledu na konfiguracni soubor
  -O             onetime /
  
  -1             Bude kontrolovat databaze jen jednou denne

Add       
 a  ...  Pridat polozku
  
  -a             do souboru 'annual' (svatky/narozeniny)
  -o             do souboru 'onetime' (dulezite udalosti)

Delete
 d  ... Zrusit polozku

  -a             v souboru 'annual'
  -o             v souboru 'onetime'

Priklad: \"vyroci -NOa -d 27/1/1978\" 
   -prohleda pouze soubor 'annual' tak, jako by dnes bylo 27.ledna 1978
");
	exit(0);
}

void main(int argc, char *argv[])
{
	int	mode,what;
	int	d,m,y;
	char	c;
	
	opterr=0;	/* prevent getopt() from printing error messages */
	
	if(argc == 2 && argv[1][0]=='I' && argv[1][1]==0)
		Install();
	
	InitConfig();
	
	if(argc==1)
	{
		mode=M_CHECK;
	}
	else
	{
		if(argv[1][0]!='-')
			if(argv[1][1]==0)
			{
				switch(argv[1][0])
				{
					case	'c':	mode=M_CHECK;	break;
					case	'a':	mode=M_ADD;		break;
					case	'e':	mode=M_EDIT;	break;
					case	'd':	mode=M_DEL;		break;
/*					case	'I':	Install(); break;	*/
					case	'h':
					case	'?':	usage();
					default:		failprog(1,"chyba: Netusim co po me chces. Parametr '%c' neznam.\n",argv[1][0]);
				}
			}
			else
				failprog(1,"chyba: Nevim co mi chces sdelit parametrem '%s'.\n",argv[1]);
		else
			mode=M_CHECK;
	}
	
	what=E_ONETIME;
	
	switch (mode)
	{
		case	M_CHECK:	debug("M_CHECK:\n"); 
							while((c=getopt(argc,argv,"nNaAoO1d:"))!=-1)
								switch(c)
								{
									case	'n':	cfg.ndflag=1;	break;
									case	'N':	cfg.ndflag=0;	break;
									case	'a':	cfg.anflag=1;	break;
									case	'A':	cfg.anflag=0;	break;
									case	'o':	cfg.otflag=1;	break;
									case	'O':	cfg.otflag=0;	break;
									case	'1':	cfg.onceAday=1;break;
									case	'd':	if(sscanf(optarg,"%4d/%4d/%4d",&d,&m,&y)!=3)
														failprog(2,"chyba: Datum musi byt ve formatu dd/mm/yyyy. '%s' je nesmysl...\n",optarg);
													else
													{
														cfg.tdday=d; 
														cfg.tdmon=m; 
														cfg.tdyear=y; 
														cfg.tdabs=AbsDay(y,m,d);
													}
													break;
									default:		usage();
								}
							break;
							
		case	M_ADD:	debug("M_ADD:\n"); 
							while((c=getopt(argc,argv,"ao"))!=-1)
								switch(c)
								{
									case	'a':	what=E_ANNUAL;  break;
									case	'o':	what=E_ONETIME; break;
									default:	usage();
								}
							break;
							
		case	M_EDIT:	debug("M_EDIT:\n"); 
							while((c=getopt(argc,argv,"aoc"))!=-1)
								switch(c)
								{
									case	'a':	what=E_ANNUAL;  break;
									case	'o':	what=E_ONETIME; break;
									case	'c':	what=E_CONFIG;  break;
									default:	usage();
								}
							break;
							
		case	M_DEL:	debug("M_DEL\n"); 
							while((c=getopt(argc,argv,"ao"))!=-1)
								switch(c)
								{
									case	'a':	what=E_ANNUAL;  break;
									case	'o':	what=E_ONETIME; break;
									default:	usage();
								}
							break;
							
		default:	failprog(99,"Jejda! Promenna 'mode' ma nejakou divnou hodnotu (%d). Umiiraaam...\n",mode);
	}
	
	switch(mode)
	{
		case	M_CHECK:	ModeCheck(); break;
							
		case	M_ADD:	ModeAdd(what); break;
		
		case	M_EDIT:	ModeEdit(what); break;
		
		case	M_DEL:	ModeDelete(what); break;
	}
}
