#ifndef __VYROCI_H
#define __VYROCI_H

#include "version.h"
#include "config.h"

#define	Str_vyroci1	CzStr_vyroci1

#define	M_CHECK	0
#define	M_ADD		1
#define	M_EDIT	2
#define	M_DEL		3

#define	E_ANNUAL		1
#define	E_ONETIME	2
#define	E_CONFIG		4

typedef struct
{
	char	pconfig[DIR_LN];
	char	pdir[DIR_LN];
	
	long	tdabs;
	int	tdday;
	int	tdmon;
	int	tdyear;
	long	lastrun;
	
	int	onceAday;
	char	odfile[DIR_LN];
	
	char	pannual[DIR_LN];
	int	anflag;
	int	andays;
	
	char	ponetime[DIR_LN];
	int	otflag;
	int	otdays;

	char	pnameday[DIR_LN];
	int	ndflag;
	int	nddays;
} tconfig;

/* global variable */
extern	tconfig	cfg;

/* returns number of days since year 0 (prehaps), 
   but worx fine for differences between dates */
long AbsDay(int year, int month, int day);

/* returns number of given day in given year (with respect to leap years) */
/* month = {1, .. ,12} */
int DayNumInMonth(int month, int year);

/* initialize global variable 'cfg' */
void InitConfig(void);

/* process cfg.pnameday file */
int ProcessNameday(void);

/* process cfg.pannual file */
int ProcessAnnual(void);

/* process cfg.ponetime file */
int ProcessOnetime(void);

/* empty function. used instead of printf() when not debugging */
void dummy(const char *str, ...);

/* Create config file etc... */
void Install();

/* print czech strings (Today, Tomorrow, ...) */
char* CzStr_vyroci1(int days);

/* How to handle different modes */
void ModeCheck();
void ModeAdd(int what);
void ModeEdit(int what);
void ModeDelete(int what);
void ModeList(int what);

/* Add functions */
int AddAnnual();
int AddOnetime();

/* Edit functions */
int EditAnnual();
int EditOnetime();
int EditConfig();

/* Delete functions */
void DelRecord(char *rec, const char *filename);
int Delete(const char *filename);

/* Support functions */
int NumRows(void);	/* how many lines is on the screen ? */
int Question(const char *q, int y, int n, int nl);

#endif __VYROCI_H
